<template>
  <div class="flex flex-col">
    <div class="w-9/12 flex justify-end mx-auto">
      <div class="flex flex-row max-w-xs">
        <!-- Autocomplate -->
        <AutoComplate
          :prop-search="search"
          :set-prop-search="setSearch"
          :loadPlaces="loadPlaces"
        />
      </div>
    </div>

    <div class="w-9/12 mx-auto my-4">
      <div
        v-if="!loading.fetch"
        class="grid grid-cols-2 lg:lg:grid-cols-3 xl:grid-cols-4 gap-2"
      >
        <NuxtLink
          v-for="place in places"
          :key="place.place_id"
          :to="`${place.place_id}`"
        >
          <div :class="{
            card: true,
            border: true,
            'rounded-lg': true,
            'bg-white': $colorMode.value === 'dark',
          }">
            <TheImage
              :photoReference="place.photo ? place.photo.reference : null"
            />

            <div class="card-body px-2 py-4">
              <div
                :class="{
                  'font-normal': true,
                  'text-md': true,
                  'card-title': true,
                  'text-black': $colorMode.value === 'ddark',
                }"
              >
                {{ place.name }}
              </div>
              <div>
                <TheStar :rating="4.6" />
              </div>
            </div>
          </div>
        </NuxtLink>
      </div>
    </div>

    <div class="w-9/12 mx-auto">
      <div class="w-full flex justify-between">
        <button
          :class="{
            btn: true,
            'btn-outline': true,
            'btn-disabled': paginate.pageNumber === 1,
          }"
          @click="loadPlaces({ action: 'previous', pageToken: paginate.previousPage })"
        >
          Previous page
        </button>

        <button
          v-if="paginate.nextPage"
          :class="{
            btn: true,
            'btn-outline': true,
            'btn-disabled': !paginate.nextPage,
          }"
          @click="loadPlaces({ action: 'next', pageToken: paginate.nextPage })"
        >
          Next
        </button>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted } from 'vue'

type Photo = {
  reference: string;
  height: number;
  width: number;
}

type Place = {
  business_status: string;
  name: string;
  location: string;
  photo: Array<Photo>;
  place_id: string;
  rating: number;
  reference: string;
}

const search = ref('Bang Sue')
type Paginate = {
  pageNumber: number;
  previousPage: string|null;
  nextPage: string|null;
}

const paginate = ref<Paginate>({
  pageNumber: 0,
  previousPage: null,
  nextPage: null,
})
const places = ref<Array<Place>>([])
const paginateStack = ref<Array<string>>([''])
const loading = ref({
  fetch: false,
  autocomplate: false,
})

type RestaurantResponse = {
  statusCode: number
  current_page_token: string
  next_page_token: string
  results: Array<Place>
}

const loadPlaces = (params: { action: string, pageToken: string }): void => {
  loading.value.fetch = true

  if (params && params.action === 'search') {
    paginateStack.value = []
    paginate.value.pageNumber = 0
  }

  $fetch('/api/restaurants', {
    method: 'POST',
    body: {
      keyword: search.value,
      pageToken: (params && params.pageToken) ? params.pageToken : '',
    }
  })
  .then((items: RestaurantResponse) => {
    loading.value.fetch = false
    places.value = items.results

    new Promise(resolve => {
      if (params && ['search', 'next'].includes(params.action)) {
        paginateStack.value.push(items.current_page_token)
      } else {
        paginateStack.value.pop()
      }

      paginate.value.pageNumber += ['search', 'next'].includes(params.action) ? 1 : -1
      // Set Default = 1
      paginate.value.pageNumber = (paginate.value.pageNumber !== 0)
        ? paginate.value.pageNumber
        : 1

      resolve(true)
    })
    .then(() => {
      // -2 is Previous Page
      // -1 is Current Page Referent by Array Index
      paginate.value.previousPage = paginateStack.value[paginate.value.pageNumber - 2]
      paginate.value.nextPage = items.next_page_token
    })
  })
}

const setSearch = (item: string) => {
  search.value = item
}

onMounted(() => {
  loadPlaces({ action: 'search', pageToken: '' })
})
</script>
